#include<bits/stdc++.h>
using namespace std;

const int maxn=1e5 + 3;
int n, q;
vector<int> children[maxn];
int ans[maxn];
int parent[maxn];

void update(int x){
    if(parent[x]==-1){
        return ;
    }
    ans[parent[x]]+=ans[x];
    ans[parent[x]]++;

    update(parent[x]);
}

int main(){
ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n;

for(int i=1; i<=n; i++){
    parent[i]=-1;
}

for(int i=1; i<=n-1; i++){
    int u, v;
    cin>>u>>v;
    children[u].push_back(v);
    parent[v]=u;
}

for(int i=1; i<=n; i++){
    if(children[i].size()==0){
        ans[i]=0;
        update(i);
    }
}

cin>>q;
while(q--){
    int x;
    cin>>x;
    cout<<ans[x]<<endl;
}

return 0;
}

